/*+
|                                               |
|     Trigger: DTULTATU_DIMEDWGRUPOP            |  
|     Tabela : DIMEDWGRUPOP                     |
|                                               |
|     Criao:                                  |
|     06/09/2007 - Luiz Passos                  |
|                                               |
+*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DIMEDWGRUPOP'  and
            type = 'TR'                       and
            u.uid = o.uid                     and
            u.name = USER)
   DROP TRIGGER DTULTATU_DIMEDWGRUPOP
GO

CREATE TRIGGER DTULTATU_DIMEDWGRUPOP
ON DIMEDWGRUPOP
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
         (SELECT 'DIMEDWGRUPOP', 'NRSEQUEDIME='   + NRSEQUEDIME +
                                ';CDGRUPOPER='   + CDGRUPOPER + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE DIMEDWGRUPOP
      SET DTULTATUDIMDWGR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(DIMEDWGRUPOP.NRSEQUEDIME, 0) = ISNULL(INSERTED.NRSEQUEDIME, 0)) AND
            (ISNULL(DIMEDWGRUPOP.CDGRUPOPER, 0) = ISNULL(INSERTED.CDGRUPOPER, 0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_DIMEDWGRUPOP','4.11.176';
GO

