function MeusProdutosController(General, templateManager, ScreenService, MessageService, MeusProdutosService, Utilities) {
    /* global Constants */
    let interval = null;
    let imgBkp = null;
    let dsProdBkp = null;
    let self = this;

	this.widgetOnEnter = function(widget) {
        const filterRow = {
            COMDSPRODUTO: widget.getField('COMDSPRODUTO').defaultValue,
            COMDSIDFOTOFILESERV: widget.getField('COMDSPRODUTO').defaultValue,
        };       
        
        Utilities.startFilter(widget, filterRow);
    };
    
    this.detalhesProd = function(widget){
        let widgetDetalhes = widget.container.getWidget('detalhesProduto');
        ScreenService.openSwipe(widgetDetalhes);
        widgetDetalhes.currentRow.FOTOPROD = widget.currentRow.FOTOPROD != null ? widget.currentRow.FOTOPROD : window.undefinedImage;
        widgetDetalhes.currentRow.DSPRODUTO = widget.currentRow.DSPRODUTO != null ? widget.currentRow.DSPRODUTO : ' ';
        widgetDetalhes.view();
    };
    
    this.edit = function (widget) {
		imgBkp = widget.currentRow.FOTOPROD;
		dsProdBkp = widget.currentRow.DSPRODUTO;
		if (widget.currentRow.FOTOPROD && widget.currentRow.FOTOPROD != window.undefinedImage) {
			widget.getField('REMOVE_IMAGE').isVisible = true;
		} else {
			widget.getField('REMOVE_IMAGE').isVisible = false;
		}
		General.edit(widget);
	};
	
	this.cancelEdit = function(widget){
	    widget.currentRow.FOTOPROD = imgBkp;
	    widget.currentRow.DSPRODUTO = dsProdBkp;
		delete widget.currentRow.IMAGE_UPLOAD;
	    widget.view();
	    widget.activate();
	};
	
	this.aplicarFiltro = function(widget){
		const filter = widget.appliedFilter.FILTER_ROW;
				
		const tProduto = Util.isEmptyOrBlank(filter.CDPRODINI) && Util.isEmptyOrBlank(filter.CDPRODFIN) ? 'T' : '';
		
		var filtro = [
			{
		        "name": "CDFORNECED",
		        "operator": "=",
		        "value": getLocalVar('CDFORNECED')
	    	},
			{
				"name": 'CDARVPRODINI',
				"operator": '=',
				"value": filter.CDPRODINI
			},
			{
				"name": 'CDARVPRODFIN',
				"operator": '=',
				"value": filter.CDPRODFIN
			},
			{
				"name": 'TPRODUTO',
				"operator": '=',
				"value": tProduto
			},
			
			{
				"name": 'COMDSPRODUTO',
				"operator": '=',
				"value": filter.COMDSPRODUTO
			},
			{
				"name": 'COMDSIDFOTOFILESERV',
				"operator": '=',
				"value": filter.COMDSIDFOTOFILESERV
			}
		];

		widget.dataSourceFilter = filtro;
		widget.reload();
	};
	
	this.onUploadPhoto = function (widget) {
		if (!interval) {
			let b64Bkp = Util.getNestedProperty(widget, ["currentRow", "IMAGE_UPLOAD", "0", "b64File"]);
			interval = setInterval(function () {
				var b64 = Util.getNestedProperty(widget, ["currentRow", "IMAGE_UPLOAD", "0", "b64File"]);
				var imageUpload = widget.currentRow.IMAGE_UPLOAD;
				if (!Util.isEmptyOrBlank(imageUpload) && b64Bkp != b64) {
					var validExt = widget.getField('IMAGE_UPLOAD').validations.extensions.value;
					var fileExt = '.' + imageUpload[0].name.split(".").pop();
					if (validExt.indexOf(fileExt) != -1) {
						widget.currentRow.FOTOPROD = imageUpload[0].b64File;
						widget.getField('REMOVE_IMAGE').isVisible = true;
					} else {
						widget.currentRow.IMAGE_UPLOAD.splice(widget.currentRow.IMAGE_UPLOAD.indexOf(imageUpload), 1);
						widget.getField('IMAGE_UPLOAD').fileList = widget.currentRow.IMAGE_UPLOAD;
						widget.currentRow.FOTOPROD = window.undefinedImage;
					}
					templateManager.updateTemplate();
					clearInterval(interval);
					interval = null;
				}
			}, 500);
		}
	};
	
	this.removeImg = function (widget) {
		var remove = function () {
			widget.currentRow.FOTOPROD = window.undefinedImage;
			widget.currentRow.IMAGE_UPLOAD = null;
			widget.getField('REMOVE_IMAGE').isVisible = false;
			templateManager.updateTemplate();
		};
		let config = {
            type: "question",
            icon: "question",
            actions: [
    			{
    				label: ScreenService.i18n('Sim'),
    				code: remove
    			},
    			{
    				label: ScreenService.i18n('Não')
    			}
    		]
        };
		MessageService.showCustomDialogByCode('confirmDeleteImage', null, config);
	};
	
	this.saveImageDescription = function (widget) {
		if(widget.isValid()){
			let currentRow = widget.currentRow;
			let widgetProdutos = widget.container.getWidget('meusProdutos');
			let fotoProd = widget.currentRow.FOTOPROD;
			let dsProduto = widget.currentRow.DSPRODUTO;
			if (fotoProd === undefined || fotoProd.length === 0 || fotoProd === window.undefinedImage) {
				widget.currentRow.FOTOPROD = null;
			}
			if(dsProduto === undefined || dsProduto === ' '){
				currentRow.DSPRODUTO = null;
			}
			currentRow.CDFORNECED = getLocalVar('CDFORNECED');
			currentRow.CDPRODUTO = widgetProdutos.currentRow.CDPRODUTO;
			currentRow.DSIDFOTOFILESERV = widgetProdutos.currentRow.DSIDFOTOFILESERV;
			currentRow.FOTOPROD = currentRow.FOTOPROD != window.undefinedImage ? currentRow.FOTOPROD : null;
			MeusProdutosService.saveImgDescriptionProd(widget.currentRow).then(function (success) {
				delete widget.currentRow.IMAGE_UPLOAD;
				widgetProdutos.reload().then(function(){
					let data = success.dataset.data;
					currentRow.FOTOPROD = data.PATHIMAGE != null ? data.PATHIMAGE : window.undefinedImage;
					currentRow.DSPRODUTO = data.DSPRODUTO;
	    	    	widget.view();
				});
	    	    
			});
		}
	};
	
	this.savePhotosAutomatic = function(widget){
		let widgetProdutos = widget.container.getWidget('meusProdutos');
		widget.currentRow.CDFORNECED = getLocalVar('CDFORNECED');
		if(widget.isValid() && widget.currentRow.UPLOAD_AUT && widget.currentRow.UPLOAD_AUT.length){
			MeusProdutosService.savePhotosAutomaticZip(widget.currentRow).then(function (success) {
				let data = success.dataset.data;
				delete widget.currentRow.UPLOAD_AUT;
				let arrayError = self.montaMensagemLog(data);
				ScreenService.closePopup();
				widgetProdutos.reload();
				if(arrayError.length){
					General.showErrorMessages(widgetProdutos, arrayError, ScreenService.i18n("Log Upload Automático"));
				}
				MessageService.notificationMessageByCode("successOnUpload", null, Constants.successNotification);
			});
		} else {
			MessageService.showMessageByCode("chooseFileUpload", null, Constants.alertMessage);
		}
	};
	
	this.montaMensagemLog = function(data) {
		let arrayError = [];
		if(data.ERROREXTENSION.length) {
			arrayError.push(ScreenService.i18n("ATENÇÃO: Serão aceitos apenas os arquivos com extensão png, jpeg e jpg dentro da pasta compactada."));
			arrayError.push(ScreenService.i18n("O(s) seguinte(s) arquivo(s) armazenados no zip possui(em) extensão incorreta, logo não foram salvos:"));
			data.ERROREXTENSION.forEach(function (row) {
				arrayError.push(row);
			});
			arrayError.push(' ');
		}
		if(data.ERRORNAMEARCHIVE.length) {
			arrayError.push(ScreenService.i18n("O(s) seguinte(s) arquivo(s) possui(em) um nome que não corresponde a nenhum produto cadastrado para este fornecedor:"));
			data.ERRORNAMEARCHIVE.forEach(function (row) {
				arrayError.push(row);
			});
		}
		
		return arrayError;
	};
	
	function setFieldDataProd(widget) {
	   	widget.getField("EXIBEPRODDESC").dataSource.data.forEach(data => {
            data.name = ScreenService.i18n(data.name);
        });
	}
	
	this.confirmImport = function(widget) {
		let widgetProdutos =widget.container.getWidget('meusProdutos');
		widget.currentRow.CDFORNECED = getLocalVar('CDFORNECED');
		if(widget.isValid() && widget.currentRow.EXCELIMPORT && widget.currentRow.EXCELIMPORT.length){
			MeusProdutosService.importDescription(widget.currentRow).then(function (success) {
				let data = success.dataset.data;
				delete widget.currentRow.EXCELIMPORT;
				let arrayError = self.montaMensagemLogDescription(data);
				ScreenService.closePopup();
				widgetProdutos.reload();
				if(arrayError.length){
					General.showErrorMessages(widgetProdutos, arrayError, ScreenService.i18n("Log Importação"));
				}
				MessageService.notificationMessageByCode("successOnImport", null, Constants.successNotification);
			}, function(err) {
				if(err.data && err.data.dataset && err.data.dataset.error){
					ScreenService.showMessage(err.data.dataset.error);
				}else{
            		ScreenService.showMessage(err.data.error);
				}
        	});
		} else {
			MessageService.showMessageByCode("chooseFileImport", null, Constants.alertMessage);
		}
	};
	
	this.montaMensagemLogDescription = function(data) {
		let arrayError = [];
		if(data.ERRORCODPROD.length){
			arrayError.push(ScreenService.i18n('O(s) seguinte(s) código(s) de produtos não foram encontrados, logo não foram salvos:'));
			data.ERRORCODPROD.forEach(function (row) {
				arrayError.push(row);
			});
			arrayError.push(' ');
		}
		
		if(data.ERRORCOLUMNEMPTY.length) {
			arrayError.push(ScreenService.i18n('A(s) seguinte(s) linhas possuem colunas vazias:'));
			data.ERRORCOLUMNEMPTY.forEach(function (row) {
				arrayError.push(row);
			});
		}
		
		return arrayError;
	};
	
	this.openPopupOptionsReport = function(widget){
		let widgetRelatorio = templateManager.container.getWidget("reportWidget");
    	ScreenService.openPopup(widgetRelatorio);
    	setFieldDataProd(widgetRelatorio);
	};
	
	this.downloadModeloPlanilha = function(widget){
		let row =  {
			CDFORNECED: getLocalVar('CDFORNECED'),
			EXIBEPRODDESC: widget.currentRow.EXIBEPRODDESC
		};
		General.openReport("product#/downloadModeloPlanilha","ECO00102", row);
		ScreenService.closePopup();
	};
	
	this.uploadFoto = function() {
		const widgetUploadAuto = templateManager.container.getWidget('uploadAutomatico');
		
		ScreenService.openPopup(widgetUploadAuto).then(() => {
			const fieldCheck = widgetUploadAuto.getField('CHECK_COD_CLIENTE');
			
			fieldCheck.checked = true;
			fieldCheck.setValue(true);
		});
	};
	
	this.setDefaultValueFilter = function(widget) {};
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MeusProdutosController', MeusProdutosController);
});